from wolframclient.evaluation import WolframLanguageSession
from wolframclient.language import wl, wlexpr
from rich import print
import unicodedata

session = WolframLanguageSession()
frequencies = {}


def remove_accents(data: str):
    return "".join(
        (
            c
            for c in unicodedata.normalize(
                "NFD", data
            )  # Normalization Form D (NFD) - 	Canonical Decomposition
            if unicodedata.category(c) != "Mn"  # Nonspacing mark (accents)
        )
    )


with open("liste_francais.txt", "r", encoding="utf-8") as f:
    words = f.readlines()

words = [w.replace("\n", "") for w in words]
words = [w for w in words if len(w) == 5]
words = [remove_accents(w).lower() for w in words]

for i, w in enumerate(words):
    frequencies[w] = session.evaluate(wl.WordFrequencyData(w))
    print(f"{i  +1}/{len(words)}", end="\r")

session.terminate()

print(frequencies)
