#include "tool-test.h"

void test_tool_init_destroy(void) {
   set_gamemode(TOOL_ASSISTED);
   initialize_game();

   destroy_game();
}

void test_compute_matches_should_remain_BALAI(void) {
    // Arrange
    char **target = malloc(sizeof(char *));
    target[0] = malloc((WORD_LENGHT + 1) * sizeof(char));
    strcpy(target[0], "BALAI");

    // Act
    set_gamemode(TOOL_ASSISTED);
    initialize_game();

    set_answer("BALAI");

    set_try("BRUTE");
    Pattern *pattern = generate_pattern();
    possibility_t **p = compute_matches("BRUTE", pattern);
   
    free(pattern);
    pattern = NULL;

    set_try("BARRE");
    pattern = generate_pattern();
    p = compute_matches("BARRE", pattern);

    free(pattern);
    pattern = NULL;

    set_try("BANAL");
    pattern = generate_pattern();
    p = compute_matches("BANAL", pattern);

    free(pattern);
    pattern = NULL;

    // Assert
    TEST_ASSERT_EQUAL_INT(get_remaining_bank_count(), 1);
    TEST_ASSERT_EQUAL_STRING_ARRAY(target, get_remaining_bank(), get_remaining_bank_count());

    free(target[0]);
    free(target);

    destroy_game();
}
