#ifndef BANK_H_
#define BANK_H_

#include "../wordle/wordle.h"
#include <ctype.h>
#include <ncurses.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>

#define BANK_PATH "./liste_francais.txt"

/**
 * @brief Count the amount of word
 *
 * @return int
 */
int count_words();

/**
 * @brief Get a random word from the list
 *
 * @return char*
 */
char *get_random_word();

/**
 * @brief Get the word bank
 *
 * @return char**
 */
char **get_bank();

/**
 * @brief Get the bank size
 *
 * @return int
 */
int get_bank_size();

#endif