#include "wordle-test.h"

void test_gamemode_should_be_solo(void) {
    set_gamemode(SOLO);
    initialize_game();

    TEST_ASSERT_EQUAL_INT(SOLO, get_gamemode());
    destroy_game();
}

void test_gamemode_should_be_versus(void) {
    set_gamemode(VERSUS);
    initialize_game();

    TEST_ASSERT_EQUAL_INT(VERSUS, get_gamemode());
    destroy_game();
}

void test_gamemode_should_be_computer(void) {
    set_gamemode(TOOL_ASSISTED);
    initialize_game();

    TEST_ASSERT_EQUAL_INT(TOOL_ASSISTED, get_gamemode());
    destroy_game();
}

void test_answer_shoud_be_balai(void) {
    set_gamemode(SOLO);
    initialize_game();
    char target[WORD_LENGHT + 1] = "BALAI";

    set_answer(target);

    TEST_ASSERT_EQUAL_STRING(target, get_answer());
    destroy_game();
}

void test_validate_letter_should_be_false(void) {
    set_gamemode(SOLO);
    initialize_game();

    for (int i = '\0'; i <= '@'; i++)
        TEST_ASSERT_FALSE(validate_letter(i));
    destroy_game();
}

void test_validate_letter_should_be_true(void) {
    set_gamemode(SOLO);
    initialize_game();

    for (int i = 'a'; i <= 'z'; i++)
        TEST_ASSERT_TRUE(validate_letter(i));

    for (int i = 'A'; i <= 'Z'; i++)
        TEST_ASSERT_TRUE(validate_letter(i));
    destroy_game();
}

void test_generate_pattern_should_return_all_0(void) {
    set_gamemode(SOLO);
    initialize_game();
    Pattern target[WORD_LENGHT] = {WRONG, WRONG, WRONG, WRONG, WRONG};

    set_answer("BALAI");
    set_try("PONTS");

    Pattern *pattern = generate_pattern();

    TEST_ASSERT_EQUAL_INT_ARRAY(target, pattern, WORD_LENGHT);

    free(pattern);
    destroy_game();
}
